package org.maxkey.boot.monitor;

import org.springframework.context.annotation.Configuration;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
import org.springframework.security.config.annotation.web.configuration.WebSecurityConfigurerAdapter;
import org.springframework.security.web.authentication.SavedRequestAwareAuthenticationSuccessHandler;
import org.springframework.security.web.csrf.CookieCsrfTokenRepository;

@Configuration
@EnableWebSecurity
public class MonitorSecurityConfigurer extends WebSecurityConfigurerAdapter {


    @Override
    protected void configure(HttpSecurity http) throws Exception {
        // ¼ɹ
        SavedRequestAwareAuthenticationSuccessHandler successHandler = new SavedRequestAwareAuthenticationSuccessHandler();
        successHandler.setTargetUrlParameter("redirectTo");
        successHandler.setDefaultTargetUrl("/");

        http.authorizeRequests()
                //֤
                .antMatchers(
                            "/login",           //¼ҳ
                            "/assets/**",       //̬ļ
                            "/actuator/**",     //springboot-adminص
                            "/instances/**"     //springboot-adminصʵϢ
                ).permitAll()
                //Ҫ¼
                .anyRequest().authenticated()
                //¼
                .and().formLogin().loginPage("/login").successHandler(successHandler)
                //ǳ
                .and().logout().logoutUrl("/logout").logoutSuccessUrl("/login")
                .and().httpBasic()
                .and().csrf()
                .csrfTokenRepository(CookieCsrfTokenRepository.withHttpOnlyFalse())
                .ignoringAntMatchers(
                        "/instances",
                        "/actuator/**"
                );

    }
}
